#include <sys/time.h>
#include <time.h>
#include <stdio.h>


/* Here's a handy perl script to set any timeout you want:

   perl -e 'require "timelocal.pl"; print &timelocal(0,0,0,9,9,93);'

   The arguments to timelocal are (sec, min, hours, mday, mon, year).
   These are all 0 based indexing so the 7th day of the month is
   really 6 to the perl script.
   */
/* New way: use 
   ../scripts/expiretime hour:minute:second month/day/year >> expire.c
   and then edit expire.c to move the time line where it goes.
   [BDyess]
*/

static time_t expire = 895851999;

void 
checkExpire(verbose)
    int     verbose;
{
    time_t  now;

    now = time(NULL);
    if (verbose) {
	printf("This client expires on %s\n", ctime(&expire));
	return;
    }
    if (now > expire) {
	printf("\
    I'm sorry.  This client has expired.  You may bypass the expire by\n\
  using the -o option which disables RSA authentication.  Expired\n\
  clients are not supported by paradise-workers.\n\
    You can find a new set of binaries on ftp.cs.umn.edu in the\n\
  directory /users/glamm/paradise/bin/.  If you have any problems mail to\n\
  paradise-workers@reed.edu\n");
	exit(0);

    } else if (now + 10 * 24 * 60 * 60 > expire) {
	printf("This client expires in %d days.\n", (int) (expire - now) / (60 * 60 * 24));
    }
}
